# Custom Publishing Options

This module allows you to create custom publishing options for nodes. It allows
you to add to the default options of Publish, Promote to Front Page, and Sticky.
It also ingrates with views to allow you add as a field, sort and filter by, your
custom options.

It now allows each of the different options to be shown only on selected node types,
as well as integration with Actions. Custom Publishing Options also have granular
permissions per role, per option.

For a full description of the module, visit the
[project page](https://www.drupal.org/project/custom_pub).

Submit bug reports and feature suggestions, or track changes in the
[issue queue](https://www.drupal.org/project/issues/custom_pub).


## Table of contents

- Requirements
- Installation
- Recommended Modules
- Configuration
- Maintainers


## Requirements

This module requires no modules outside of Drupal core.


## Installation

Install as you would normally install a contributed Drupal module. For further
information, see
[Installing Drupal Modules](https://www.drupal.org/docs/extending-drupal/installing-drupal-modules).


## Configuration

Configure Custom Publishing Options on your site at admin/structure/custom_pub, under the Structure menu.
On each new option created, set the Node types the option should be available from.
Go to the Permissions page. Grant permission to each role that should be able to use the new publishing option.

Note that, using just Custom Publishing Options, on its own, a role needs `'administer nodes'` in order to see any of the core publishing options at all. 
Without it, they still see custom publishing options, just not 'status', 'sticky', or 'promoted' states. 


## Recommended Modules

- Actions:
    If you want to use Custom Publish Options with Node operations bulk form, then you can enable Actions
    and configure an action.
    Visit `https://www.drupal.org/docs/8/core/modules/action/overview` for further information.
- Views:
    Enabling Views opens up a whole new avenue of displaying content with Custom Publishing Options. 
    Create your View any way you like, and under Filter you will find all Custom Publishing Options available. 
    Create archived content sections by creating an Archive option, and Filter by that option!
- Override Node Options:
    If you want greater permissions to allow a role to use custom publishing options or core states (status,
    sticky, promoted), it is suggested that you also pick up Override Node Options module. 
    This module adds access control to each publish state at the role level, so 'administer nodes' is not
    a requirement.


## Maintainers

- Adam Gregory - [arcaneadam](https://www.drupal.org/u/arcaneadam)
- Kevin Quillen - [kevinquillen](https://www.drupal.org/u/kevinquillen)
- Vladimir Roudakov - [VladimirAus](https://www.drupal.org/u/vladimiraus)
- Gisle Hannemyr - [gisle](https://www.drupal.org/u/gisle)
- Jake Bell - [jacobbell84](https://www.drupal.org/u/jacobbell84)
- Daniel Boulet - [dboulet](https://www.drupal.org/u/dboulet)

**Supporting organization:**

- [Tomato Elephant Studio](https://www.drupal.org/tomato-elephant-studio)
- [ZenSource](https://www.drupal.org/zensource)
